(function($, window, undefined){

	/**
	* GLOBALS
	*/

	var 
		tmp = 				[],
		field = 			'',
		prefixfield = 		'',
		preBaseCls = 		'ok error',
		form = 				'',
		doSubmit = 			false,
		filterInfo = 		''
	;

	$.fn.getUrlParams = function (url) {

		url = '?'+url
  		var re = /(?:\?|&(?:amp;)?)([^=&#]+)(?:=?([^&#]*))/g,
      	match, 
      	params = {},
      	decode = function (s) {return decodeURIComponent(s.replace(/\+/g, " "));};

  		if (typeof url == "undefined") return false;

  		while (match = re.exec(url)) {
  			
    		params[decode(match[1])] = decode(match[2]);
    		//params[match[1]] = match[2];
  		}

  		return params;
	}

	/**
	*	Plugin que envia un formulario validando si contiene informacio
	* 	y agregando validaciones y codigo css para mostrar informacion
	* 	al usuario.
	*
	*	@var formId: 	ID del formulario a enviar
	*	@var prefix: 	variable que sirve para completar el idenfiticador de los identificadores ( un div id="prefix-field_name")
	*/
	$.fn.sendForm = function(formId, prefix){

		// Form Id
		// ----------------------------------------------------------------------
		form = $(formId);

		// Realizamos el evento blur para cada elemento del form que sera enviado
		// ----------------------------------------------------------------------
		xData = $(this).getUrlParams( form.serialize() );
		for (x in xData)
		{
			$('#'+x).on('blur', function(){
				$.fn.validateClsField( $(this).attr('class'), $(this).val(), $(this) );
				$.fn.validateClsField( $(this).attr('class'), $(this).val(), $('#span-'+$(this).attr('id') ) );
			});
		}

		// Form submit function()
		// ----------------------------------------------------------------------
		form.submit(function() {
			var 
				$this = 		$(this),
				button = 		$('input[type="submit"]#doSubmit');
				$formita = 		$(formId),
				foundError =	0,
				retInfo = 		'';
			;

			doSubmit = false;

			button.attr('disabled', 'disabled');

			// Obtenemos la informacion del formulario separada por campos
			// ------------------------------------------------------------
			xData = $this.getUrlParams( $formita.serialize() );
			for (x in xData)
			{
				filterInfo = $('#'+x).each(function(){
					//var retInfo = $.fn.validateClsField( $(this).attr('class'), xData[x], $('#'+prefix+x) );
					var retInfo = $.fn.validateClsField( $(this).attr('class'), xData[x], $('#'+x) );
					retInfo = $.fn.validateClsField( $(this).attr('class'), $(this).val(), $('#span-'+$('#'+x).attr('id') ) );
					if (retInfo==false) foundError++;
					
		        });
			}

			doSubmit = (foundError>0) ? false : true;

			button.removeAttr('disabled');
			
			return doSubmit;
		});


	};

	// Function to validate input data.
	// ----------------------------------------------------------------------
	$.fn.validateClsField = function(fieldCls, field, prefixfield){
		var $this = $(this),
			validated = true;

		// Default value baseCls
		// ------------------------------------
		prefixfield.removeClass( preBaseCls );

		if ( $.inArray('[required]', fieldCls.split(' ') ) > -1 )
		{
			validated = $this.isRequired(field);
		}
		else if ( $.inArray('[text-only]', fieldCls.split(' ') ) > -1 )
		{
			validated = ($this.just_text(field)) ? true : false;
		}
		else if ( $.inArray('[zipcode]', fieldCls.split(' ') ) > -1 )
		{
			validated = ($this.valid_USZipCode(field)) ? true : false;
		}
		else if ( $.inArray('[validate-ssn]', fieldCls.split(' ') ) > -1 )
		{
			validated = ($this.validate_ssn(field)) ? true : false;
		}
		else if ( $.inArray('[numbers]', fieldCls.split(' ') ) > -1 )
		{
			validated = ($this.valid_numbers(field)) ? true : false;
		}
		else if ( $.inArray('[phone-number]', fieldCls.split(' ') ) > -1 )
		{
			validated = ($this.valid_phone_number(field)) ? true : false;
		}
		else if ( $.inArray('[email]', fieldCls.split(' ') ) > -1 )
		{
			validated = ($this.validateEmail(field)) ? true : false;
		}

		if ( validated == false )
			prefixfield.addClass('error');
		else
			prefixfield.addClass('ok');

		return validated;

	}

	// Function to validate if input had value
	// ----------------------------------------------------------------------
	$.fn.isRequired = function(val){
		return (val != '') ? true : false;
	}

	// Function to validate zip code and filter value 00000
	// ----------------------------------------------------------------------
	$.fn.valid_USZipCode = function(zip){
		var $this = $(this),
			expresion = /(^\d{5}$)|(^\d{5}-\d{4}$)/;

		if ( zip == '00000' ) return false;

		return expresion.test(zip);
	}

	// Function to validate if is numeric
	// ----------------------------------------------------------------------
	$.fn.valid_numbers = function(numbers){
		var $this = $(this);
		if ( !$this.isRequired(numbers) ) return false;

		return !isNaN(numbers);
	}

	// Function to validate if is valid phone number format
	// ----------------------------------------------------------------------
	$.fn.valid_phone_number = function(numbers){
		var $this = $(this),
			expresion = /(^\d{10}$)/;

		// Eliminamos todos los que NO sean numericos
 		numbers = numbers.replace(/[^\d.]/g, "");

 		// Validamos que tenga 10 digitos
	    return expresion.test(numbers);
	}

	// Function to validate if is valid SSN format
	// ----------------------------------------------------------------------
	$.fn.validate_ssn = function(numbers){
		var $this = $(this),
			expresion = /(^\d{9}$)/;

		// Eliminamos todos los que NO sean numericos
 		numbers = numbers.replace(/[^\d.]/g, "");
 		
 		// Validamos que tenga 10 digitos
	    return expresion.test(numbers);
	}

	// Function to validate just text input
	// ----------------------------------------------------------------------
	$.fn.just_text = function(field){
		var $this = $(this),
			expresion = /^[A-Za-z\W]+$/;
	    return expresion.test(field);
	}

	// Function to validate alfanumeric values
	// ----------------------------------------------------------------------
	$.fn.alfanumericos = function(field){
		var $this = $(this),
			expresion = /^[a-zA-Z0-9]+/;
		;

		return expresion.test(value);

	}

	// Function to validate email
	// ----------------------------------------------------------------------
	$.fn.validateEmail = function(field){  
   		var $this = $(this),
   			expresion = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;  
   		return expresion.test(field);  
	} 

})(jQuery, window);